#include <linux/pci_ids.h>
#ifndef PCI_DEVICE_ID_INTEL_IOAT
	#define PCI_DEVICE_ID_INTEL_IOAT 0x1a38
#endif
#ifndef PCI_DEVICE_ID_INTEL_IOAT_CNB
	#define PCI_DEVICE_ID_INTEL_IOAT_CNB 0x360b
#endif
#ifndef PCI_DEVICE_ID_INTEL_IOAT_SNB
	#define PCI_DEVICE_ID_INTEL_IOAT_SNB 0x402f
#endif
#ifndef PCI_DEVICE_ID_INTEL_IOAT_SCNB
	#define PCI_DEVICE_ID_INTEL_IOAT_SCNB 0x65ff
#endif

#include <linux/interrupt.h>
#ifndef IRQF_SHARED
	#define IRQF_SHARED SA_SHIRQ
#endif

#include <linux/version.h>
#if (LINUX_VERSION_CODE < KERNEL_VERSION(2,6,19))
typedef irqreturn_t (*old_irq_handler_t)(int, void*, struct pt_regs *);
typedef irqreturn_t (*new_irq_handler_t)(int, void*);

static inline int __request_irq(unsigned int irq,
				new_irq_handler_t handler,
				unsigned long flags,
				const char *devname,
				void *dev_id)
{
	old_irq_handler_t old_handler = (old_irq_handler_t) handler;
	return request_irq(irq, old_handler, flags, devname, dev_id);
}

#define request_irq(irq, handler, flags, devname, dev_id) \
__request_irq((irq), (handler), (flags), (devname), (dev_id))
#endif

// either a kernel change is needed, or we need something like this in kernel
#ifndef CONFIG_SMP
#include <asm/smp.h>
#undef cpu_physical_id
#define cpu_physical_id(cpu) (cpuid_ebx(1) >> 24)
#endif
